



// Globals
var appLang='en';// getLanguage();
var appLocale='eng'; //(appLang=='it'?'ita':'eng');

// Organisms database

// click/touch events
var _click='click';
var _doubleclick='doubleclick';

// Variables used to pass results to page view
var pageR;
var shotR; 

// Screenshots cache
var sCache=[]; 


// Loads db
var database=getAllData(); // The whole levels db
var idxbyletter=[]; // per answerlen db

var _lastTitle='4 Pics 1 Words Answers';



var _perpage=100;
var _admobPublisherId_android='ca-app-pub-2553401124262351/2871926627'; // AdMob Publisher id banner - Android
var _admobPublisherId_ios='ca-app-pub-2553401124262351/8912970228';

var _admobPublisherId=_admobPublisherId_android;
if(_mgsIsIos) _admobPublisherId=_admobPublisherId_ios;


// select the right Ad Id according to platform
  var admobid = {};
  if( /(android)/i.test(navigator.userAgent) ) { // for android & amazon-fireos
    admobid = {
      banner: _admobPublisherId_android, // or DFP format "/6253334/dfp_example_ad"
     
    };
  } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
    admobid = {
      banner: _admobPublisherId_ios, // or DFP format "/6253334/dfp_example_ad"
  
    };
  } else { // for windows phone
    admobid = {
      banner: _admobPublisherId_ios, // or DFP format "/6253334/dfp_example_ad"
      
    };
  }


//////////////////////////////

/*
 * Get current system language (like 'en' or 'it')
 * */
function getLanguage() {
	// Identifica lingua dal navigator
	var lary=navigator.language.split('-');	
	var lang=lary[0].slice(0,2);
	if(lang!='it' && lang!='en') return 'en'; // Default
	return lang;
}

// Check element visibility
function isVisible(ele) {
    if(ele.css('display')!='hidden' && ele.css('visibility')!='hidden' && ele.height()>0) {
        return(true);
    } else {
        return(false);
    }
}




// On device: call startup function at deviceready event
$(document).bind('deviceready', onDeviceReady);


/**
 * Hack to debug on Chrome
 * */
$(document).ready(function() {
	var isChrome = !!window.chrome;
	if(isChrome) {
		console.log('Emulate in Chrome - enable debug');
		$_debug=true;
		onDeviceReady();	
	}
});

/*
 * App startup function
 * */
function onDeviceReady() {
	
	// FastClick INIT
	if(typeof FastClick != 'undefined') {
		FastClick.attach(document.body);
	}
		

	// Build per letter indexes
	for(var i=0;i<database.length;i++) {
		var d=database[i];
		var answer=d['Screenshot']['answer'].trim();
		var l=answer.length;
		var j=0;
		if(idxbyletter[l]) { 
			j=idxbyletter[l].length;
		}
		else {
			idxbyletter[l]=[];
		}
		idxbyletter[l][j]=d;
		setShotCacheData(d['Screenshot']['id'],d);
	}

	// Sets analytics
	ga_storage._setAccount('UA-51903850-3');
	

	showHomepage();	

	// ADS
	initAds();
	
}

/**
 * Admob ads init
 * */
function initAds() {
	
	if(typeof AdMob != 'undefined') {
		AdMob.createBanner( {
			adId: admobid.banner, 
			position: AdMob.AD_POSITION.TOP_CENTER, 
			autoShow: true } );
	}
}


function showHomepage() {
	// Templates
	$('#main').html(Templates.home());
	$('#main').show();
	$('#screenshot').hide();
	$('#about').hide();
	// Show search Box
	$('#searchForm').html(Templates.searchForm());	
	$('#searchForm').show();
	$('#fname').bind('change',function() {
			// search
			doSearch();
	});	
		
	// Header
	setHeaderMain(true,'4 Pics 1 Word Answers');
	
	// Hide Main Menu
	$('#mainmenu').hide();
	
	// Bind events
	for(var i=3;i<10;i++) {
		$('#btLett'+i).data('letters',i);
		$('#btLett'+i).bind(_click,function (e) {				
			//console.log(e);
				showPerletterPage($(e.toElement).data('letters'),_perpage,0);
		});
	}
	
	scrollToTop();
	
	// Exit if on android
	if(_mgsIsAndroid) {
		$(document).off('backbutton');
		$(document).on('backbutton',function() {
				navigator.app.exitApp();
		});
	}
	
	ga_storage._trackPageview('HomePage');
	
}



function showPerletterPage(letters,perpage,page) {		
	perpage = perpage || _perpage;
	page=page || 0;
	$('#fname').val(''); // Empty search box
	var data=idxbyletter[letters];
	
	pageR=[];
	var n=data.length;
	for(var i=0;i<perpage;i++) {
		var j=(page*perpage)+i;
		if(!data[j]) continue;
		var d=data[j];
		pageR[pageR.length]=d;
		//setShotCacheData(d['Screenshot']['id'],d);
	}
	
	$('#main').html(Templates.pagelen({data: pageR, letters: letters, perpage: perpage, page: page}));
	$('#main').show();
	$('#searchForm').show();
	$('#screenshot').hide();
	$('#about').hide();
	// Header
	setHeaderMain(false,letters+" letters");
	scrollToTop();
	
	ga_storage._trackPageview('PerLetterPage');
	
}

function doSearch() {
	var q=$('#fname').val();
	if(q && q.length>2) {
		var rex=new RegExp($('#fname').val(),'i');
		pageR=[];
		var n=database.length;
		for(var i=0;i<n;i++) {
			//console.log(database[i]);
			var d=database[i];
			var k=d['Screenshot']['keywords'];
			
			if(k.search(rex)<0) continue;
			
			// OK
			pageR[pageR.length]=d;
			//setShotCacheData(d['Screenshot']['id'],d);
		}

		$('#main').html(Templates.pagesearch({data: pageR,q:q}));
		$('#main').show();
		$('#screenshot').hide();
				
		// Header		
		setHeaderMain(false,' ');	
	}	
}


function showScreenshotPage(id) {
	
	var data=getShotCacheData(id);
	if(data) {
		
		// Current shot
		shotR=data;
		
		// Templates
		$('#screenshot').html(Templates.pagescreenshot());
		$('#main').hide();		
		$('#about').hide();			
		$('#screenshot').show();
		$('#searchForm').hide();		
				
		// Header
		setHeaderDetail();
	}
	else {
		getScreenshotData(id);
	}
	
	ga_storage._trackPageview('ScreenshotPage');
	
}


function getScreenshotData(id) {
	for(var i=0;i<database.length;i++) {
		var d=database[i];
		if(d['Screenshot']['id']==id) {
			//setShotCacheData(id,d);
			showScreenshotPage(id);
			break;
		}
	}
}


/*
 * Screenshot Cache
 * */
function getShotCacheData(id) {
		if(sCache[id]) return sCache[id];
		return false; 
}

function setShotCacheData(id,data) {
	sCache[id]=data;	
}



/*
 * Show main header
 * */
function setHeaderMain(noshowhome,title) {
	if(!title) title=_lastTitle;
	_lastTitle=title;
	$('#pageHeader').html(Templates.pageHeader({noshowhome: noshowhome,title: title}));
	$(document).off('backbutton');	
	$(document).on('backbutton',function() {
			showHomepage();
	});

	// Search form toggle
/*	
	$('#btSearch').bind(_click,function() {				
		if(isVisible($('#searchForm'))) {
			$('#searchForm').hide();
			$('#btSearch').removeClass('active');
		}
		else {
			showSearchPage();
			$('#searchForm').show();
			$('#main').show();
			$('#screenshot').hide();
			$('#about').hide();			
			$('#btSearch').addClass('active');			
			scrollToTop();
		}		
	});	
*/	
	
	$('#btMenu').on(_click,function() {				
		showHomepage();
		/*
		if(isVisible($('#mainmenu'))) {			
			hideMenu();
		}
		else {
			showMenu();
		}*/		
	});
	$('#btAbout').on(_click,function() {				
		showAboutPage();
	});
	
}


function showMenu() {	
	
	$('#mainmenu').html(Templates.mainmenu());					
	$('#mainmenu').show();
	$('#mainmenu').css('z-index','1000');
	$('.menu').css('z-index','1000');


/*
	// Bind Menu buttons
	$('#menuBtBookmarks').on(_click,function() {		
		showBookmarksPage();
		hideMenu();
	});*/
	$('#menuBtAbout').off(_click);
	$('#menuBtAbout').on(_click,function() {		
		showAboutPage();
		hideMenu();
	});
	$('#menuBtMain').off(_click);
	$('#menuBtMain').on(_click,function() {		
		showHomepage();
		hideMenu();
	});


	// Bind events
	for(var i=3;i<10;i++) {
		$('#menuLett'+i).off(_click);
		$('#menuLett'+i).data('letters',i);
		$('#menuLett'+i).on(_click,function (e) {				
			//console.log(e);
	
				showPerletterPage($(e.toElement).data('letters'),_perpage,0);
				hideMenu();
		});
	}

/*
	$('#menuBtClose').bind(_click,function() {
		hideMenu();
	});
*/
	$('#mainmenu').bind('swipeLeft',function() {
		hideMenu();
	});
	
	$('#pageContent').bind(_click,function() {
		hideMenu();
	});

		
}

function hideMenu() {
	$('.menu').css('z-index','1');
	$('#mainmenu').hide();
}

/*
 * Show detail page header
 * */
function setHeaderDetail() {
	$('#pageHeader').html(Templates.pageHeaderD());	
	$('#btBack').bind(_click,function() {
		setHeaderMain();
		$('#screenshot').hide();
		$('#main').show();
		$('#searchForm').show();			
	});	
	$(document).off('backbutton');
	$(document).on('backbutton',function () {
		setHeaderMain();
		$('#screenshot').hide();
		$('#main').show();
		$('#searchForm').show();
	});	
}

/*
 * Scroll page to top
 * */
function scrollToTop() {
	// Scroll view top
	var $el = $('#pageContent');
	var el = $el[0];
	el.scrollTop = 0;
}

/*
 * Show bookmarks page
 * */
function showBookmarksPage() {	
	sRes=listBookmarks();
	setHeaderMain(false,' ');	
	$('#screenshot').hide();
	$('#searchForm').show();
	$('#main').html(Templates.starred({data: sRes}));	
	$('#main').show();	
	$('#about').hide()
	scrollToTop();
}

function showSearchPage() {		
	setHeaderMain(false,' ');	
	$('#screenshot').hide();
	$('#searchForm').hide();	
	$('#searchForm').html(Templates.searchForm());	
	$('#searchResults').show();		
	$('#about').hide()
	scrollToTop();
	
	ga_storage._trackPageview('SearchResultsPage');
	
}

function showAboutPage() {	
	setHeaderMain(false,' ');	
	$('#searchForm').hide();
	$('#details').hide();
	$('#main').hide()
	$('#about').html(Templates.about({terms: useterms}));
	$('#about').show();		
	scrollToTop();
	
	ga_storage._trackPageview('AboutPage');
	
}



function openFBUrl(id) {
	var rec=getRecordById(id);
	var ueftlurl=encodeURIComponent('http://www.fishtanklab.com/'+appLocale+'/site/dbview/'+id+'&t='+rec['uename']+'&utm_source=ftlcatalog');	
	openExtUrl("http://www.facebook.com/sharer.php?u="+ueftlurl);
}

function openTWUrl(id) {
	var rec=getRecordById(id);
	var ueftlurl=encodeURIComponent('http://www.fishtanklab.com/'+appLocale+'/site/dbview/'+id+'&t='+rec['uename']+'&utm_source=ftlcatalog');	
	openExtUrl("http://twitter.com/home?status="+ueftlurl);
}

function openErrUrl(id) {
	var errurl='http://www.fishtanklab.com/'+appLocale+'/site/erreport/'+id+'&utm_source=ftlcatalog';
	openExtUrl(errurl);
}

function openGsearchUrl(id) {				
	var rec=getRecordById(id);
	var gsearchurl='http://www.google.com/cse?cx=partner-pub-9185645222144388%3A0230674535&ie=UTF-8&q='+rec['uename'];
	openExtUrl(gsearchurl);
}

 
 
 
 
 
///////////////
// Bookmarks



function isBookmarked(id) {
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	var found=false;
	if(aryB) {		
		var len=aryB.length, i;
		for(i=0;i<len;i++) {
			if(aryB[i]==id) {
				found=true;
				break;
			}
		}
	}
	return found;
}

function addBookmark(id) {
	if(isBookmarked(id)) return true; // Evita duplicati
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	aryB[aryB.length]=id;	
	var str=aryB.toString()
	window.localStorage.setItem("ftl_bookmarks", str);
	window.localStorage.setItem("ftl_bookmarks_n",aryB.length);
	return true;
}

function removeBookmark(id) {
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	var aryN=[];
	var len=aryB.length, i;
	for(i=0;i<len;i++) {
		if(aryB[i]!=id) {
			aryN[aryN.length]=aryB[i];
		}
	}
	var str=aryN.toString()
	window.localStorage.setItem("ftl_bookmarks", str);
	window.localStorage.setItem("ftl_bookmarks_n",aryN.length);
	return true;
}

function listBookmarks() {
	var ret=[];
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	if(aryB) {
		var len=aryB.length, i;
		var dblen=appDb.length, j;
		for(i=0;i<len;i++) {
			for(j=0;j<dblen;j++) {
				if(aryB[i]==appDb[j]['id']) {
					ret[ret.length]=appDb[j];
				}
			}				
		}	
	}
	return ret;
}

function toggleDbstar(id) {		
	if(id && id>0) {
		if(isBookmarked(id)) {		
			removeBookmark(id);
		}
		else {
			addBookmark(id);
		}
		showStarState(id);
	}
} 

function showStarState(id) {
	if(isBookmarked(id)) {
		$('#star').attr('src',"img/star_on.png");
	}
	else {
		$('#star').attr('src',"img/star_off.png");
	}
}



/////////////////////////////////////////////////
// Apri External URL
function openExtUrl(url) {    

	if(_mgsIsChrome || _mgsIsFF) {		
		 popupWin = window.open(url,'open_window','menubar, toolbar, location, directories, status, scrollbars, resizable, dependent, width=640, height=480, left=0, top=0');
	}
    else if(_mgsIsIos) {		
        window.open(url, "_system");
    }
	else {		
		navigator.app.loadUrl(url, { openExternal:true } ); 
	}
}



////////////
	


function goRate() {
   if (_mgsIsIos) {							
		openExtUrl('itms-apps://itunes.apple.com/'+appLang+'/app/aquarium-organisms-catalog/id591610219?ls=1&mt=8'); // or itms://
	} else if (_mgsIsAndroid) {
		openExtUrl('https://play.google.com/store/apps/details?id=com.fishtanklab.ftlcatalog');
	} /*else if (device_bb) {
		openExtUrl('http://appworld.blackberry.com/webstore/content/<applicationid>');
	}*/
	neverRate();	
}

function neverRate() {
	window.localStorage.setItem("config.idxNoRate_"+_version,1);
}


//////////////
function gotoFtl() {openExtUrl("http://www.fishtanklab.com");}
function gotoFtlFB() {openExtUrl("https://facebook.com/fishtanklab");}
function gotoFtlTW() {openExtUrl("https://twitter.com/fishtanklab");}





