



// Globals
var appLang=getLanguage();
var appLocale=(appLang=='it'?'ita':'eng');
// Organisms database


// click/touch events
var _click='click';
var _doubleclick='doubleclick';


// Variables used to pass results to page view
var pageR;
var shotR; 

// Screenshots cache
var sCache=[]; 

// CFG
var _baseUrl='http://qp.mgshareware.com/GameApis';
var _gameid=3;
var _token='X'; // FAKE
var _perpage=12;

//////////////////////////////

/*
 * Get current system language (like 'en' or 'it')
 * */
function getLanguage() {
	// Identifica lingua dal navigator
	var lary=navigator.language.split('-');	
	var lang=lary[0].slice(0,2);
	if(lang!='it' && lang!='en') return 'en'; // Default
	return lang;
}

// Check element visibility
function isVisible(ele) {
    if(ele.css('display')!='hidden' && ele.css('visibility')!='hidden' && ele.height()>0) {
        return(true);
    } else {
        return(false);
    }
}

window.onload=function() {
	
	/* Non sembra funzionare correttamente
	// Touch support? If yes remapl clicks to taps
	if (typeof document.body.ontouchstart !== "undefined") {
			_click='singletap';
			_doubleclick='doubletap';	
	}
	*/


	showHomepage();	
	
}

function showHomepage() {
	// Templates
	$('#main').html(Templates.home());
	$('#main').show();
	$('#screenshot').hide();
	// Show search Box
	$('#searchForm').html(Templates.searchForm());	
	$('#fname').bind('change',function() {
			// search
			doSearch();
	});	
		
	// Header
	setHeaderMain();
	
	// Hide Main Menu
	$('#mainmenu').hide();
	
	

	// Bind events
	for(var i=3;i<11;i++) {
		$('#btLett'+i).data('letters',i);
		$('#btLett'+i).bind(_click,function (e) {				
			//console.log(e);
				showPerletterPage($(e.toElement).data('letters'),_perpage,0);
		});
	}

}



function showPerletterPage(letters,perpage,page) {		
	perpage = perpage || _perpage;
	page=page || 0;
	$('#fname').val(''); // Empty search box
	
	var url=_baseUrl+'/getScreenshotsPerAnswerLen/'+_gameid+'/'+letters+'/'+perpage+'/'+page+'/'+_token;
	//console.log(url);	
	$.ajax({
	    url: url,
	    dataType: 'jsonp',  // JsonP
	    jsonp: 'callback',
	    jsonpCallback: 'myCallback',
        crossDomain: true,
        ifModified: true,
        cache: true,
	    success: function(data,status,xhr) {			
			pageR=[];			
			$.each(data,function(i,val) {
				// load screenshot data and push it in pageR
				pageR[i]=val;
				//console.log(val);
				// And store in cache
				setShotCacheData(val['Screenshot']['id'],val);
			});	               
	        $('#main').html(Templates.pagelen({data: pageR, letters: letters, perpage: perpage, page: page}));
			$('#main').show();
			$('#screenshot').hide();
			
			// Header
			setHeaderMain();
	    },
	    error: function() {
	        //TODO: handle the error
	        alert('Communication Error');
	    }
	});	
}

function doSearch() {
	var q=$('#fname').val();
	if(q) {
		var url=_baseUrl+'/searchHints/'+_gameid+'/'+escape(q)+'/'+_token;
		//console.log(url);	
		$.ajax({
			url: url,
			dataType: 'jsonp',  // JsonP
			jsonp: 'callback',
			jsonpCallback: 'myCallback',
			crossDomain: true,
			ifModified: true,
			cache: true,
			success: function(data,status,xhr) {			
				pageR=[];			
				$.each(data,function(i,val) {
					// load screenshot data and push it in pageR
					pageR[i]=val;
					//console.log(val);
					// And store in cache
					setShotCacheData(val['Screenshot']['id'],val);
				});	               
				$('#main').html(Templates.pagesearch({data: pageR,q:q}));
				$('#main').show();
				$('#screenshot').hide();
				
				// Header
				setHeaderMain();
			},
			error: function() {
				//TODO: handle the error
				alert('Communication Error');
			}
		});	
	}	
}

function showScreenshotPage(id) {
	
	var data=getShotCacheData(id);
	if(data) {
		
		// Current shot
		shotR=data;
		
		// Templates
		$('#screenshot').html(Templates.pagescreenshot());
		$('#main').hide();		
		$('#about').hide();			
		$('#screenshot').show();
				
		// Header
		setHeaderDetail();
	}
	else {
		getScreenshotData(id);
	}
	
	

}

function getScreenshotData(id) {
	var url=_baseUrl+'/getScreenshotData/'+id+'/'+_token;
	//console.log(url);	
	$.ajax({
	    url: url,
	    dataType: 'jsonp',  // JsonP
	    jsonp: 'callback',
	    jsonpCallback: 'myCallback',
        crossDomain: true,
        ifModified: true,
        cache: true,
	    success: function(data,status,xhr) {						
			// Cache
			setShotCacheData(id,data);
			// And go back to show			
			showScreenshotPage(id);		
	    },
	    error: function() {
	        //TODO: handle the error
	        alert('Communication Error');
	    }
	});
}



/*
 * Screenshot Cache
 * */
function getShotCacheData(id) {
		if(sCache[id]) return sCache[id];
		return false; 
}

function setShotCacheData(id,data) {
	sCache[id]=data;	
}



/*
 * Show main header
 * */
function setHeaderMain() {
	$('#pageHeader').html(Templates.pageHeader());	
	// Search form toggle
/*	
	$('#btSearch').bind(_click,function() {				
		if(isVisible($('#searchForm'))) {
			$('#searchForm').hide();
			$('#btSearch').removeClass('active');
		}
		else {
			showSearchPage();
			$('#searchForm').show();
			$('#main').show();
			$('#screenshot').hide();
			$('#about').hide();			
			$('#btSearch').addClass('active');			
			scrollToTop();
		}		
	});	
*/	
	
	$('#btMenu').bind(_click,function() {				
		if(isVisible($('#mainmenu'))) {			
			hideMenu();
		}
		else {
			showMenu();
		}		
	});
	
}


function showMenu() {
	$('#mainmenu').html(Templates.mainmenu());				
	$('#mainmenu').show();

	// Bind Menu buttons
	$('#menuBtBookmarks').bind(_click,function() {		
		showBookmarksPage();
		hideMenu();
	});
	
	$('#menuBtAbout').bind(_click,function() {		
		showAboutPage();
		hideMenu();
	});
	$('#menuBtMain').bind(_click,function() {		
		showHomepage();
		hideMenu();
	});


	// Bind events
	for(var i=3;i<11;i++) {
		$('#menuLett'+i).data('letters',i);
		$('#menuLett'+i).bind(_click,function (e) {				
			//console.log(e);
				showPerletterPage($(e.toElement).data('letters'),_perpage,0);
				hideMenu();
		});
	}


	$('#menuBtClose').bind(_click,function() {
		hideMenu();
	});

	$('#mainmenu').bind('swipeLeft',function() {
		hideMenu();
	});
	
	$('#pageContent').bind(_click,function() {
		hideMenu();
	});

		
}

function hideMenu() {
	$('#mainmenu').hide();
}

/*
 * Show detail page header
 * */
function setHeaderDetail() {
	$('#pageHeader').html(Templates.pageHeaderD());	
	$('#btBack').bind(_click,function() {
		setHeaderMain();
		$('#screenshot').hide();
		$('#main').show();			
	});	
}

/*
 * Scroll page to top
 * */
function scrollToTop() {
	// Scroll view top
	var $el = $('#pageContent');
	var el = $el[0];
	el.scrollTop = 0;
}

/*
 * Show bookmarks page
 * */
function showBookmarksPage() {	
	sRes=listBookmarks();
	setHeaderMain();	
	$('#screenshot').hide();
	$('#searchForm').hide();
	$('#main').html(Templates.starred({data: sRes}));	
	$('#main').show();	
	$('#about').hide()

}

function showSearchPage() {		
	setHeaderMain();	
	$('#screenshot').hide();
	$('#searchForm').hide();	
	$('#searchForm').html(Templates.searchForm());	
	$('#searchResults').show();		
	$('#about').hide()
	

}

function showAboutPage() {	
	sRes=appDb;
	setHeaderMain();	
	$('#searchForm').hide();
	$('#details').hide();
	$('#searchResults').hide()
	$('#about').html(Templates.about());
	$('#about').show();		

}



function openFBUrl(id) {
	var rec=getRecordById(id);
	var ueftlurl=encodeURIComponent('http://www.fishtanklab.com/'+appLocale+'/site/dbview/'+id+'&t='+rec['uename']+'&utm_source=ftlcatalog');	
	openExtUrl("http://www.facebook.com/sharer.php?u="+ueftlurl);
}

function openTWUrl(id) {
	var rec=getRecordById(id);
	var ueftlurl=encodeURIComponent('http://www.fishtanklab.com/'+appLocale+'/site/dbview/'+id+'&t='+rec['uename']+'&utm_source=ftlcatalog');	
	openExtUrl("http://twitter.com/home?status="+ueftlurl);
}

function openErrUrl(id) {
	var errurl='http://www.fishtanklab.com/'+appLocale+'/site/erreport/'+id+'&utm_source=ftlcatalog';
	openExtUrl(errurl);
}

function openGsearchUrl(id) {				
	var rec=getRecordById(id);
	var gsearchurl='http://www.google.com/cse?cx=partner-pub-9185645222144388%3A0230674535&ie=UTF-8&q='+rec['uename'];
	openExtUrl(gsearchurl);
}

 
 
 
 
 
///////////////
// Bookmarks



function isBookmarked(id) {
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	var found=false;
	if(aryB) {		
		var len=aryB.length, i;
		for(i=0;i<len;i++) {
			if(aryB[i]==id) {
				found=true;
				break;
			}
		}
	}
	return found;
}

function addBookmark(id) {
	if(isBookmarked(id)) return true; // Evita duplicati
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	aryB[aryB.length]=id;	
	var str=aryB.toString()
	window.localStorage.setItem("ftl_bookmarks", str);
	window.localStorage.setItem("ftl_bookmarks_n",aryB.length);
	return true;
}

function removeBookmark(id) {
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	var aryN=[];
	var len=aryB.length, i;
	for(i=0;i<len;i++) {
		if(aryB[i]!=id) {
			aryN[aryN.length]=aryB[i];
		}
	}
	var str=aryN.toString()
	window.localStorage.setItem("ftl_bookmarks", str);
	window.localStorage.setItem("ftl_bookmarks_n",aryN.length);
	return true;
}

function listBookmarks() {
	var ret=[];
	var str=window.localStorage.getItem("ftl_bookmarks");
	if(!str) str='';
	var aryB=str.split(',');
	if(aryB) {
		var len=aryB.length, i;
		var dblen=appDb.length, j;
		for(i=0;i<len;i++) {
			for(j=0;j<dblen;j++) {
				if(aryB[i]==appDb[j]['id']) {
					ret[ret.length]=appDb[j];
				}
			}				
		}	
	}
	return ret;
}

function toggleDbstar(id) {		
	if(id && id>0) {
		if(isBookmarked(id)) {		
			removeBookmark(id);
		}
		else {
			addBookmark(id);
		}
		showStarState(id);
	}
} 

function showStarState(id) {
	if(isBookmarked(id)) {
		$('#star').attr('src',"img/star_on.png");
	}
	else {
		$('#star').attr('src',"img/star_off.png");
	}
}



/////////////////////////////////////////////////
// Apri External URL
function openExtUrl(url) {    

	if(_mgsIsChrome || _mgsIsFF) {		
		 popupWin = window.open(url,'open_window','menubar, toolbar, location, directories, status, scrollbars, resizable, dependent, width=640, height=480, left=0, top=0');
	}
    else if(_mgsIsIos) {		
        window.open(url, "_system");
    }
	else {		
		navigator.app.loadUrl(url, { openExternal:true } ); 
	}
}



////////////
	


function goRate() {
   if (_mgsIsIos) {							
		openExtUrl('itms-apps://itunes.apple.com/'+appLang+'/app/aquarium-organisms-catalog/id591610219?ls=1&mt=8'); // or itms://
	} else if (_mgsIsAndroid) {
		openExtUrl('https://play.google.com/store/apps/details?id=com.fishtanklab.ftlcatalog');
	} /*else if (device_bb) {
		openExtUrl('http://appworld.blackberry.com/webstore/content/<applicationid>');
	}*/
	neverRate();	
}

function neverRate() {
	window.localStorage.setItem("config.idxNoRate_"+_version,1);
}


//////////////
function gotoFtl() {openExtUrl("http://www.fishtanklab.com");}
function gotoFtlFB() {openExtUrl("https://facebook.com/fishtanklab");}
function gotoFtlTW() {openExtUrl("https://twitter.com/fishtanklab");}





